# Certifikáty Let's Encrypt v prostředí FI MU

## Potřebuji tohle?

Možná ne :-). Certifikační autorita [Let's Encrypt](http://letsencrypt.org)
je přístupná komukoli, kdo je schopen příslušným protokolem prokázat
vlastnictví doménového jména tak, že na příslušné URL umístí požadovanou výzvu.
Jedna z možností tedy je celé to nastudovat, zprovoznit některého klienta,
a řídit si vystavování a obnovování certifikátů ve vlastní režii, bez
spolupráce `unix@fi`.

Vystavený certifikát od LE má platnost tři měsíce, zatímco jiné certifkační
autority (například TERENA, kterou máme zdarma k dispozici přes CESNET)
poskytují až dva roky. Certifikát od LE je získatelný s menší byrokracií
a část práce s vystavením a obnovováním certifikátů může převzít unix@fi
za pomocí zde přístupných skriptů.

## Chci certifikát! Jak na to?

Příklad: potřebuji certifikát pro svůj nový projekt `https://zverinec.cz`, který
chci provozovat na svém serveru `zoo.fi.muni.cz` (projekt a server
ale nemusí nutně mít různá jména, může jít o totéž).

* Na počitači, kde tento projekt má běžet, zkonfigurujte a spusťte HTTP server,
například Apache (HTTPS zatím ne, nemáte certifikát). Ujistěte se se,
že po zadání (`http://zverinec.cz/`) do prohlížeče dostanete stránku ze svého
serveru.

* Zkopírujte si na svůj server tento repozitář:

    git clone https://gitlab.fi.muni.cz/unix/letsencrypt-fi

* Zkontrolujte, že na počítači jsou nainstalované balíky `openssl` a `perl`.

* Vygenerujte tajný klíč a certificate request skriptem
`./le-gen-csr zverinec.cz`. Výstupem tohoto skriptu jsou tři soubory:

  * `zverinec.cz.key` - tajný klíč, který nikomu nedávejte. Zkopírujte jej do příslušného systémového adresáře (na RHEL/CentOS/Fedoře do `/etc/pki/tls/private/`)
  * `zverinec.cz.crt` - dočasný self-signed certifikát, určený k tomu, abyste si mohli všechno nakonfigurovat a nemuseli čekat na vystavení "ostrého" certifikátu.
I tento umístěte do příslušného systémového adresáře, například do `/etc/pki/tls/certs/`.
  * `zverinec.cz.csr` - certificate request. Na základě tohoto vystaví LE skutečný certifikát.

* Nakonfigurujte HTTPS server tak, aby používal výše uvedený klíč a certifikát.
Pro Apache 2.4 můžete použít tyto direktivy:

    SSLCertificateFile /etc/pki/tls/certs/zverinec.cz.crt
    SSLCertificateKeyFile /etc/pki/tls/private/zverinec.cz.key

* Nainstalujte skripty `le-acme-put-token` a `le-renewed-cert` do systémových
adresářů a povolte k nim přístup přes SSH z počítače `thetis.fi.muni.cz`:

    cp le-acme-put-token le-renewed-cert /usr/local/sbin/
    cat le-fi-authorized-keys >> /root/.ssh/authorized\_keys

* V obou skriptech je na začátku konfigurace, kde můžete upravit například
jiné umístění souboru s certifikáty, stromu webových stránek nebo příkazu
pro znovunačtení konfigurace HTTPS serveru.

* Nyní už zbvývá jen požádat unix@fi o vystaven9 certifikátu. K žádosti přiložte
dříve vygenerovaný certificate request:

> Prosím o vygenerování a průběžnou aktualizaci certifikátu Let's Encrypt
> pro můj projekt `zverinec.cz`.
> Skripty z gitlab repozitáře `unix/letsencrypt-fi`
> jsou přístupné přes SSH na uživatele `root@zverinec.fi.muni.cz`.
> Přikládám certificate request (soubor `zverinec.cz.csr`).
> Kontaktní adresa na správce tohoto projektu je `zverinec-devel@fi.muni.cz`.

* Poté `unix@fi` zajistí vystavení certifikátu a již pomocí nainstalovaných skriptů přes SSH se certifikát dostane na váš server.

* Skripty samozřejmě můžete zkoumat a upravovat dle libosti.

